#ifndef _APSET_H
#define _APSET_H

#include "apvector.h"
template <class itemType>
class apset
{
  public:
    apset();

    // accessors
    
    bool contains(const itemType & item) const;  // is item in the set?
    void print(ostream & output)         const;  // print all items
    int  size()                          const;  // # elements in set
    
    // mutators

    void add(const itemType & item);        // add item to set (no duplicates)
    void makeEmpty();                       // empty it out
    void remove(const itemType & item);

    // operators

    const apset<itemType>&
    operator *= (const apset<itemType> & rhs);   // intersection with
    const apset<itemType>&
    operator += (const apset<itemType> & rhs);   // union with

  private:

    int find(const itemType & item) const;  // index of item in myList

    apvector<itemType> myList;
    int                myCount;
};

#include "apset2.cpp"

#endif
