#include "hanggame.h"
#include "word.h"
#include "alphabet.h"

HangGame::HangGame()
{
   apstring filename;
   myGallows.Reset(Gallows::easy);
   
   cout << "enter file for words ";
   cin >> filename;
   
   myDictionary.Load(filename);
   
}

char HangGame::GetGuess(Alphabet & alph)
{
    char ch;
    while (true)
    {
        cout << "enter a letter: ";
        cin >> ch;
        if (alph.IsLetterUsed(ch))
        {
            cout << "already guessed " << ch << endl;
        }
        else
        {
            return ch;
        }
    }
}

void HangGame::Play()
{
    Word w(myDictionary.GetString());
    myGallows.Reset(Gallows::easy);
    Alphabet alph;
    char ch;
    
    while (true)
    {
        if (w.IsGuessed())
        {
            cout << "you win!!" << endl;
            break;
        }
        if (myGallows.IsHung())
        {
            cout << "you lose!!" << endl;
            w.MakeKnown();
            w.Print(cout);
            break;
        }
        
        cout << "Guess this word" << endl;
        w.Print(cout);
        cout << endl;
        myGallows.Display(cout);
        cout << endl;
        cout << "Letters unused : ";
        alph.Print(cout);
        
        ch = GetGuess(alph);
        alph.ProcessLetter(ch);
        if (! w.Contains(ch))
        {
            myGallows.AddPart();
        }
        else
        {
            w.ProcessLetter(ch);
        }
    }
}