#include "word.h"

Word::Word(const apstring & s)
  : myString(s),
    myDisplay(s)
{
    int k;
    int len = s.length();
    for(k=0; k < len; k++)
    {
        myDisplay[k] = '_';
    }
}

void Word::Print(ostream & output) const
{
    int k;
    int len = myString.length();
    for(k=0; k < len; k++)
    {
        output << myDisplay[k] << ' ';
    }
    output << endl << endl;
}

bool Word::IsGuessed() const
{
    return myString == myDisplay;
}

void Word::ProcessLetter(char ch)
{
    int k;
    int len = myString.length();
    for(k=0; k < len; k++)
    {
        if (myString[k] == ch)
        {
            myDisplay[k] = ch;
        }
    }
}

void Word::MakeKnown()
{
     int k;
    int len = myString.length();
    for(k=0; k < len; k++)
    {
        myDisplay[k] = myString[k];
    }   
}

bool Word::Contains(char ch) const
{
	return myString.find(ch) != npos;
}